Package org.optaplanner.core.impl.localsearch.decider.forager

## Interface LocalSearchForager<Solution_>

- All Superinterfaces:
    `EventListener`, `LocalSearchPhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`
  All Known Implementing Classes:
    `AbstractLocalSearchForager`, `AcceptedLocalSearchForager`

      public interface LocalSearchForager<Solution_>
      extends LocalSearchPhaseLifecycleListener<Solution_>

  Collects the moves and picks the next step from those for the `LocalSearchDecider`.
  See Also:
    `AbstractLocalSearchForager`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addMove​(LocalSearchMoveScope<Solution_> moveScope)` |
    `boolean` | `isQuitEarly()` |
    `LocalSearchMoveScope<Solution_>` | `pickMove​(LocalSearchStepScope<Solution_> stepScope)` |
    `boolean` | `supportsNeverEndingMoveSelector()` |

    - ### Methods inherited from interface org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Method Detail

    - #### supportsNeverEndingMoveSelector

          boolean supportsNeverEndingMoveSelector()

      Returns:
        true if it can be combined with a `Selector.isNeverEnding()` that returns true.

    - #### addMove

          void addMove​(LocalSearchMoveScope<Solution_> moveScope)

      Parameters:
        `moveScope` - never null

    - #### isQuitEarly

          boolean isQuitEarly()

      Returns:
        true if no further moves should be selected (and evaluated) for this step.

    - #### pickMove

          LocalSearchMoveScope<Solution_> pickMove​(LocalSearchStepScope<Solution_> stepScope)

      Parameters:
        `stepScope` - never null
      Returns:
        sometimes null, for example if no move is selected